///////////////////////////////////////////////
//  t\퐧䃉Cu@for PIC16F818/819
//  ֐͈ȉ
//    lcd_init()    ----- 
//    lcd_cmd(cmd)  ----- R}ho
//    lcd_data(chr) ----- P\o
//    lcd_clear()   ----- S
//    lcd_eeprom(add)  ----- EEPROMo
//////////////////////////////////////////////

//////// f[^o̓Tu֐
void lcd_out(int code, int flag)
{
	PORTx = (PORTx & 0x0F) | (code & 0xF0);
	if (flag == 0)
		output_high(rs);		//\f[^̏ꍇ
	else
		output_low(rs);		//R}hf[^̏ꍇ
	delay_cycles(1);			//NOP		
	output_high(stb);			//strobe out
	delay_cycles(2);			//NOP
	output_low(stb);			//reset strobe
}
/////// EEPROMo
void lcd_eeprom(long add)
{
	int i;
	long n;
	for (n=0; n<16; n++ )			//ő16܂
	{
		i = read_eeprom(add + n);
		if ((i == 0x00)||(i == 0xFF))	//00FFǂݍ݂ŕI
			break;
		else
			lcd_out(i, 0);		//ʂSrbgo
			lcd_out(i<<4, 0);			//ʂSrbgo
			delay_us(50);
	}
}
//////// P\֐
void lcd_data(int asci)
{
	lcd_out(asci, 0);		//ʂSrbgo
	lcd_out(asci<<4, 0);			//ʂSrbgo
	delay_us(50);				//50sec҂
}
/////// R}ho͊֐
void lcd_cmd(int cmd)
{
	lcd_out(cmd, 1);			//ʂSrbgo
	lcd_out(cmd<<4, 1);			//ʂSrbgo
	if((cmd & 0x03) != 0)
		delay_ms(2);			//2msec҂
	else
		delay_us(50);			//50usec҂
}
/////// S֐
void lcd_clear()
{
	lcd_cmd(0x01);				//R}ho
	delay_ms(15);				//15msec҂
}
/////// ֐
void lcd_init()
{
	delay_ms(30);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(5);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(1);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(1);
	lcd_out(0x20, 1);			//4bit mode set
	delay_ms(1);
	lcd_cmd(0x2E);			//DL=0 4bit mode
	lcd_cmd(0x08);			//display off C=D=B=0
	lcd_cmd(0x0C);			//display on D=1 C=B=0
	lcd_cmd(0x06);			//entry I/D=1 S=0
	lcd_cmd(0x02);			//cursor home
}
